<template>
  <div>
    <!-- Table Container Card -->
    <b-card no-body class="mb-0">
      <div class="m-2">
        <validation-observer ref="simpleRules">
          <b-form @submit.prevent>
            <div class="title">
              <h4>Nuevo proyecto</h4>
            </div>

            <br />
            <br>

            <b-row>
              <b-col cols="6">
                <b-form-group label="Nombre" label-for="name">
           
                    <b-form-input
                      v-model="project.name"
                      :state="validationName"
                      autofocus
                      maxlength="80"
                      trim
                      placeholder="Nombre"
                    />
                    <b-form-invalid-feedback :state="validationName">
                      El campo "Nombre" es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>

                <b-form-group label="Descripción" label-for="description">
           
                    <b-form-input
                      v-model="project.description"
                      :state="validationDescription"
                      placeholder="Descripción"
                      autofocus
                      maxlength="300"
                      trim
                    />
                    <b-form-invalid-feedback :state="validationDescription">
                      El campo "Descripción" es obligatorio
                    </b-form-invalid-feedback>

                </b-form-group>
 
                <b-form-group label="Cliente" label-for="client">

                    <v-select
                      v-model="project.client"
                      label="name"
                      :state="validationClient"
                      :options="clients"
                      placeholder="Selecionar cliente"
                    />
                     <b-form-invalid-feedback :state="validationClient">
                      Es olbigatorio escoger un cliente
                    </b-form-invalid-feedback>
                </b-form-group>
              </b-col>

              <!------------------------------------------>

              <b-col cols="6">
                <b-form-group label="Encargado" label-for="manager">
                  
                    <v-select
                      v-model="selectedManager"
                      label="name"
                      :state="validationManager"
                      :options="users"
                      placeholder="Selecionar encargado"
                      @input="validarManager"
                    />
                    <b-form-invalid-feedback :state="validationManager">
                      Es olbigatorio escoger un encargado de proyecto
                    </b-form-invalid-feedback>

                  
                </b-form-group>

                <b-form-group label="Equipo de trabajo" label-for="users">
 
                    <v-select
                      v-model="project.team"
                      multiple
                      :state="validationTeam"
                      :options="usersMembers"
                      label="name"
                    />
           
                    <b-form-invalid-feedback :state="validationTeam">
                      Es olbigatorio escoger un equipo de trabajo
                    </b-form-invalid-feedback>

                    <b-form-invalid-feedback :state="validationRepeat">
                      Un miembro del equipo no puede ser el encargado del proyecto
                    </b-form-invalid-feedback>
       
                </b-form-group>
               </b-col>
            </b-row> 
            <br>
            <b-row>
              <b-col cols="6">
                <b-button
                  v-ripple.400="'rgba(255, 255, 255, 0.15)'"
                  type="submit"
                  variant="primary"
                  class="mr-1"
                  :disabled="lockedSubmit.name || lockedSubmit.description || lockedSubmit.client || lockedSubmit.manager || lockedSubmit.team || lockedSubmit.repeat"
                  @click="saveProject()"
                >
                  Guardar
                </b-button>
                <b-button
                  v-ripple.400="'rgba(186, 191, 199, 0.15)'"
                  type="reset"
                  variant="outline-secondary"
                  :to="{ name: 'apps-projects-list' }"
                >
                  Cancelar
                </b-button>
              </b-col>
            </b-row>
          </b-form>
        </validation-observer>
      </div>
    </b-card>
  </div>
</template>

<script>
import BCardCode from "@core/components/b-card-code";
import { ValidationProvider, ValidationObserver } from 'vee-validate'
import {
  BCard,
  BRow,
  BCol,
  BFormGroup,
  BFormInput,
  BFormFile,
  BFormCheckbox,
  BForm,
  BButton,
  BAlert,
  BInputGroupPrepend,
  BAvatar,
  BFormInvalidFeedback,
} from "bootstrap-vue";
import Ripple from "vue-ripple-directive";
import Cleave from "vue-cleave-component";
import { required, email } from '@validations'
import vSelect from 'vue-select'

export default {
  components: {
    BCard,
    BCardCode,
    BRow,
    BCol,
    BFormGroup,
    BFormInput,
    BFormFile,
    BFormCheckbox,
    BForm,
    BButton,
    BAlert,
    BInputGroupPrepend,
    Cleave,
    BAvatar,
    ValidationProvider,
    ValidationObserver,
    vSelect,
    BFormInvalidFeedback,
  },
  directives: {
    Ripple,
  },
  data() {
    return {
      users:[],
      clients:[],
      project:{
          name:'',
          description:'',
          client:'',
          manager: '',
          team:''
      },
      siencuentra:false,
      lockedSubmit:{
        name:true,
        description:true,
        client:true,
        manager:true,
        team:true,
        repeat:false
      },
      hasWrittenDescription:false,
      hasWrittenName:false,
      usersMembers:[],
      selectedManager:'',

    }
  },
  methods: {
    saveProject() {
      // console.log(this.project);

      this.$refs.simpleRules.validate().then(success => {
        if (success) {

          this.$http.post("project/create", this.project).then((res) => {
            if (res.data.message === "agregado") {
              this.$router.push({ name: "apps-projects-list" });
              this.user = [];
            }
          }).catch((err) => {
            console.log(err);
          });
          
        }
      })
      
    },
    getUsers(){
      this.$http.get('usuarios').then(res=>{
        this.users = res.data.users
        this.usersMembers =this.users
      }).catch(err=>{
        console.log(err);
      })
    },
    getClients(){
      this.$http.get('clients').then(res=>{
        this.clients = res.data.clients
      }).catch(err=>{
        console.log(err);
      })
    }, 
    validarManager(){
      if(this.project.manager){
        this.usersMembers.push(this.project.manager)
        const index = this.usersMembers.indexOf(this.selectedManager)
        this.usersMembers.splice(index, 1)
       
      }else{
        const index = this.usersMembers.indexOf(this.selectedManager)
        this.usersMembers.splice(index, 1)

      }
      const selected = this.project.team.indexOf(this.selectedManager)
      if(selected!== -1){
        this.project.team.splice(selected, 1)
      }
      this.project.manager=this.selectedManager

    },
    
  },
  computed: {
    validationRepeat(){
   
      if(this.project.team.length>0 && this.project.manager){
  
          
          if(this.project.team.find(member => member.id === this.project.manager.id )){
            this.lockedSubmit.repeat = true
            return false
          }else{
            this.lockedSubmit.repeat = false
            return true
          }
      }
    },
    validationRepeat(){
   
      if(this.project.team.length>0 && this.selectedManager){
  
          if(this.project.team.find(member => member.id === this.selectedManager.id )){
            this.lockedSubmit.repeat = true
            return false
          }else{
            this.lockedSubmit.repeat = false
            return true
          }
      }
    },   

    validationName() {
      if (this.project.name.length > 0){
        this.hasWrittenName = true
      } 
      if(this.hasWrittenName && this.project.name.length > 0 ){
        this.lockedSubmit.name = false
        return true
      }else if(this.hasWrittenName){
        this.lockedSubmit.name = true
        return false
      }
    },
    validationDescription(){
      if (this.project.description.length > 0){
        this.hasWrittenDescription = true
      }
      if(this.hasWrittenDescription){ 
        if (this.project.description.length > 0) {
          this.lockedSubmit.description = false
          return true
        }else{
          this.lockedSubmit.description = true
          return false
        }
      } 
    },
    validationClient(){
      if (this.project.client){
        this.lockedSubmit.client = false
        return true
      }else{
        this.lockedSubmit.client = true
        return false
      }
    },
    validationManager(){
      if (this.selectedManager){
        this.lockedSubmit.manager = false
        return true
      }else{
        this.lockedSubmit.manager = true
        return false
      }
    },
    validationTeam(){
      if (this.project.team.length > 0){
        this.lockedSubmit.team = false
        return true
      }else{
        this.lockedSubmit.team = true
        return false
      }
    }
        
  },
  mounted(){
    this.getUsers()
    this.getClients()
  },

}
</script>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
